---ONELUA/AMG 3D MODULE TEST

--VARIABLES
Angle = 0;
TX = 0;
END_ANG = 0;
END_Y = 0;
JUMP = 0;
EXITV = 0;
Play_FX = 0;

os.setcpu(333)
--Init 3D / iniciar 3D
amg.init()
amg.quality(__8888) ---Image quality / Calidad de la imagen (__8888 __4444 __5551 __5650)
amg.perspective(36.0) -- Camera Field of View / Campo de vision de la camara
model3d.initphysics(10,{-20,-20,-20},{20,20,20}) --Tamao del mundo fsico

--Load sound / Cargar sonidos
BOING = sound.load("Sound/boing.wav")
FART = sound.load("Sound/fart1.wav")
RINGS = sound.load("Sound/Ring.mp3")
NRING = sound.load("Sound/NoRing.mp3")
ExitS = sound.load("Sound/ExitS.mp3")
SpringS = sound.load("Sound/Spring.mp3")
ProTracker = sound.load("Sound/SpaceDebris_1991.s3m")

--Load images / Cargar imagenes
Logos = image.load("Files/Logos.png")

--Load wavefront files as "models" / Cargar archivos wavefront como "modelos"
--A model may have more than one 3D object / Un modelo puede tener mas de un objeto 3D

BKG = model3d.load("Files/BKG.obj")
Suelo = model3d.load("Files/Suelo.obj")
Pared = model3d.load("Files/Pared.obj")
Lava = model3d.load("Files/Lava.obj")
Hierba = model3d.load("Files/Grass.obj")
END = model3d.load("Files/End.obj")
Point = model3d.load("Files/Point.obj")
Bola = model3d.load("Files/bola.obj")
L = model3d.load("Files/L.obj")
L1 = model3d.load("Files/L.obj")
Ring = model3d.load("Files/Ring.obj")
EXIT = model3d.load("Files/EXIT.obj")
SPRING = model3d.load("Files/Spring.obj")


--Changes texture quality / Cambia la calidad de la textura (__8888 __4444 __5551 __5650)
texture3d.quality(BKG,1,1,__4444) 
texture3d.quality(Suelo,1,1,__4444) 
texture3d.quality(Pared,1,1,__4444) 
texture3d.quality(Hierba,1,1,__4444) 
texture3d.quality(SPRING,1,1,__4444) 

--Change object lighting / Cambia la iluminacion de los objetos. 
--0 = off 1 = on

model3d.lighting(BKG,1,0)  
model3d.lighting(Point,1,0)  

--Load image as a texture / Cargar una imagen como textura
Brillo = texture3d.load("Files/Brillo.png",__VRAM)
texture3d.quality(Brillo,__4444)
texture3d.mapping(Brillo,__ENV,3,4) -- Enviroment map / mapeado ambiental

--Set a texture on top of the default / Aplica otra textura encima de la original
texture3d.setmulti(Pared,1,1,Brillo)

--The following models and textures will show rendered textures. Load at the end to prevent overwritting of other textures
--los siguientes modelos y texturas mostrarn texturas renderizadas. Cargar al final para evitar que sobreescriban otras texturas  
TV = model3d.load("Files/TV.obj")
model3d.lighting(TV,1,0)
texture3d.quality(TV,1,2,__8888) 

--Creates a new texture / Crea una textura nueva
Render1 = texture3d.new(64,64, __VRAM) 

--Set animated 3D texture (4 Frames)/ Define una textura 3D animada (4 imagenes)

texture3d.setframes(Point,1,1,4)
FR = 1; --frame
FRS = 1; --speed

--Adds another texture over the default  / aade otra textura sobre la del material
--texture3d.setmulti(Pared,1,1,Brillo)


--Set physics / Define objetos fsicos
model3d.setphysics(Suelo,1,{0,0,0},{0,0,0},0,__CONVEX)
model3d.setphysics(Pared,1,{0,0,0},{0,0,0},0,__CONVEX)
model3d.setphysics(Bola,1,{0,0,0},{0,0.5,0},0.1,__SPHERE)

model3d.setphysics(Ring,1,{0,0,0},{0,0,0},0,__BOX)
model3d.setphysics(L,1,{0,0,0},{0,0,0},2,__BOX)
model3d.setphysics(L1,1,{0,0,0},{0,0,0},6,__BOX)
model3d.setphysics(SPRING,1,{0,0,0},{0,0,0},0,__BOX)
model3d.setphysics(EXIT,1,{0,0,0},{0,0,0},0,__BOX)

--Start physics / Empieza a utilizar la fsica
model3d.physics(Suelo)
model3d.physics(Pared)
model3d.physics(Bola)

model3d.physics(Ring)
model3d.physics(L)
model3d.physics(L1)
model3d.physics(SPRING)
model3d.physics(EXIT)

--Initial positions / posiciones iniciales
model3d.position(Bola,1,{-2,0.5,-2})
model3d.position(L,1,{-0.3,0.5,-1.78})
model3d.position(L1,1,{-2.5,0.2,0.8})
model3d.position(Ring,1,{3,0.2,-3})
model3d.position(SPRING,1,{-3.69,0.24,0.24})
model3d.position(EXIT,1,{-3,-0.0,3})

---CAMERA 1
camera1 = cam3d.new()
poscam = {0,20,20}
cam3d.position(camera1,poscam) --Position / Posicion
cam3d.eye(camera1,{0,0,0}) --Look at / Mirar a

---CAMERA 2
camera2 = cam3d.new()
poscam1 = {0,10,0}
cam3d.position(camera2,poscam1)
cam3d.eye(camera2,{0,0,0})

---LIGHTS / LUCES
DIF = color.new(250,250,250) --Diffuse (main) color / Color difuso o principal
AMB = color.new(140,140,160) --Ambiental color / Color del ambiente
SPEC = color.new(90,90,90) --Specular or shining color / color de los brillos

ZZ = color.new(0,0,0)
RED = color.new(250,0,0)

amg.typelight(1,__DIRECTIONAL) -- Sun / Sol
amg.colorlight(1,DIF,AMB,SPEC) --Colors / colores
amg.poslight(1,{1,1,1}) --Position (direction) / posicion (direccion)

amg.typelight(2,__POINT) -- Point of light (lava) / Punto de luz (lava)
amg.colorlight(2,RED,ZZ,ZZ)
amg.poslight(2,{1.6,0,0}) 

sound.loop(ProTracker,1) --Loop sound / Reproduce el sonido indefinidamente
while true do 
	buttons.read()
	amg.begin() --Begin 3D / Comienza el 3D
	amg.gravity(0,-9.8,0) --Gravedad
	
	BallPos = model3d.getposition(Bola,1) --Get Ball position / Obtener posicin de Bola
	
	--Set camara 
    cam3d.set(camera1)
	cam3d.position(camera1,{BallPos.x-(math.cos(Angle))*4,BallPos.y+4,BallPos.z+ math.sin(Angle)*4})
	--look at the ball/ Mira a la bola
	cam3d.eye(camera1,{BallPos.x,BallPos.y,BallPos.z})
	
--///////////////////////////////////////////////
	amg.light(1,1); --enable light 1 / enciende luz 1
	amg.light(2,1)
	
	model3d.render(BKG); --Render a 3d Model / Dibuja un modelo 3D
	model3d.render(Pared);
	
	model3d.render(Lava);
	model3d.render(END);
	model3d.render(Bola);
	model3d.render(Ring);
	model3d.render(L);
	model3d.render(L1);
	
	model3d.render(SPRING);
	model3d.render(EXIT);

	--Start shadows and reflection engine / Inicia el motor de sombras y reflejos
	--"Suelo" will be rendered and will recieve shadows and produce reflections
	--"Suelo" sera dibujado, recivira sombras y producira los reflejos
	model3d.startreflection(Suelo,1)     
	    model3d.mirror(Pared,1,2,1) --"Pared" sera reflejada en "Suelo"
		model3d.mirror(END,1,2,0) --"END" will be reflected on "Suelo"		
		model3d.shadow(END,1,1) --"END" shadow will be casted on "Suelo"
		model3d.mirror(Bola,1,2,0) 
		model3d.shadow(Bola,1,1) --La sombra de "Bola" se proyectara en "Suelo"
		model3d.mirror(L,1,2,0) 
		model3d.shadow(L,1,1)	
		model3d.mirror(L1,1,2,0) 
		model3d.shadow(L1,1,1)			
	model3d.finishreflection() --Finish the engine / finaliza el motor 

	--Transparent objs, render on top of the others
	--Objetos transparentes, dibujar sobre todos los demas
	model3d.render(Hierba); 
	model3d.render(Point);
	
	amg.light(1,0); --disable light 1/ desconecta luz 1
	amg.light(2,0)
--\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\\
	
--\\\EDIT OBJECTS / TEXTURES - EDITAR OBJETOS Y TEXTURAS
 
  --Position / Posicion
    model3d.position(TV,1,{1.4,0,-2.3}) --Pos 1
	model3d.render(TV); --Render TV at Pos 1
    model3d.position(TV,1,{-3.0,0,3.77}) --Pos 2
	model3d.render(TV);	--Render TV at Pos 2
	model3d.rotation(TV,1,{0,0,0})

  --Move and rotate arrows with the ball / Mueve y rota las flechas con la bola 
	model3d.position(Point,1,{BallPos.x,BallPos.y,BallPos.z})
	model3d.rotation(Point,1,{0,math.deg(Angle),0})  	
	
  --Move and scale red arrow / mueve y escala las flechas rojas
	model3d.position(END,1,{0,END_Y,0})
    model3d.scaling(END,1,{1,1+math.sin(END_ANG)/6,1})
	
	END_Y = math.abs(math.sin(END_ANG))
	END_ANG = END_ANG + 0.04
	
  --Move Lava texture / Mueve la textura de la lava
    texture3d.trans(Lava,1,1,TX,TX)
	TX = TX + 0.01
	
  --Move Env_Map texture / Mueve la textura ambiental	
	texture3d.envmap(Brillo,0,0,math.sin(Angle))
	
  --Animate 3d texture (Ball arrows)/ Cambia Frames de la textura animada (las flechas de la bola)
    if FR == 5 then FR = 1 end
	texture3d.frame(Point,1,1,FR)
	if FRS == 6 then 
	   FR = FR + 1
       FRS = 1	   
	end
	FRS = FRS + 1;	
     
  --Move Ball / Mover la bola
  --Detect fall and reset ball / detecta cuando cae la bola
    if BallPos.y < -0.2 then 
       sound.play(FART,2)	
	   model3d.deletephysics(Bola)
	   model3d.setphysics(Bola,1,{0,0,0},{0,0.5,0},0.1,__SPHERE)
       model3d.physics(Bola)
       model3d.position(Bola,1,{-2,0.5,-2}) 	   
	end  
	---------------------------------------------------
  --Detect collision with Ring / Detecta choque con anillo
    if model3d.collision(Bola,1, Ring,1) then
	   EXITV = 1;
       sound.play(RINGS,3)	
	   model3d.deletephysics(Ring)
       model3d.position(Ring,1,{3,-1,-3}) 	   
	end  
  --Detect collision with Spring / Detecta choque con Muelle
    if model3d.collision(Bola,1,SPRING,1) then
	   model3d.setvelocity(Bola,1,{8,BallV.y,BallV.z})
       sound.play(SpringS,3)	
	end
	
  --Detect collision with EXIT / Detecta choque con EXIT
    if model3d.collision(Bola,1,EXIT,1) and EXITV == 0 then
     	  screen.print(184,151,"You need the ring") 
		  screen.print(184,166,"Necesitas el anillo ") 
		  if Play_FX == 1 then sound.play(NRING,3) end
		  Play_FX = Play_FX + 1;
    else Play_FX = 0;		  
    end  
    if model3d.collision(Bola,1,EXIT,1) and EXITV == 1 then
		  sound.play(ExitS,3)
		  answer = os.message("This is just the beggining, from now on, you can do whatever you want. \n\nEsto es solo el principio, a partir de ahora puedes hacer lo que quieras. \n\nContinue? - Continuar?",1)
          if (answer == 0) then
		      os.message("Bye bye - Hasta luego")
              os.exit()
		  else
	        BKG, Suelo, Pared, Lava, Bola, Point, L, Hierba, END = nil
		    collectgarbage()
            os.reset()			  
          end	
	end  
	---------------------------------------------------	
	
	--LEFT/RIGHT * IZQUIERDA/DERECHA
	if buttons.held.left then Angle = Angle + 0.03 end
	if buttons.held.right then Angle = Angle - 0.03 end	
	
	--Get Linear Velocity / Obtiene velocidad de la Bola
	BallV = model3d.getvelocity(Bola,1) --Gets: BallV.x BallV.y BallV.z
	
	--Forward / Avanza
	if buttons.held.up then
	   model3d.setvelocity(Bola,1,{math.cos(Angle)*2,BallV.y,-math.sin(Angle)*2})
	end	
	--Backward / Retrocede
	if buttons.held.down then
	   model3d.setvelocity(Bola,1,{math.cos(Angle)*-2,BallV.y,math.sin(Angle)*2})
	end		
	--Jump / Salta 
	if buttons.cross and JUMP == 1 then
	   model3d.setvelocity(Bola,1,{BallV.x,2.5,BallV.z})
	   sound.play(BOING,2)
	   JUMP = 0
	end
	--Detect collision with ground / Detecta colision con suelo
	if model3d.collision(Bola,1, Suelo,1) then JUMP = 1 else JUMP = 0 end

  --Print 2D / Imprime cosas 2D
	amg.mode2d(1)--1/0 Enable 2D mode / Activa modo 2D
		screen.print(8,198,"FPS: "..screen.fps())
		screen.print(8,210,"< > = Turn / Girar")
		screen.print(8,222,"Up / Arriba = Forward / Avanza")
		screen.print(8,234,"Down / Abajo = Backward / Retrocede")
		screen.print(8,246,"X = Jump / Saltar")
		image.blit(Logos,340,180)
        texture3d.draw(Render1)		
	amg.mode2d(0)
	
	--Set texture to model / Aplica una textura a un modelo
	texture3d.setcustom(TV,1,2, Render1);
	--Position and size of a texture in 2D mode.
	--Posicion y tamao de textura 3d dibujada en 2d
	texture3d.scaling(Render1,2,1.4)
	texture3d.position(Render1,64,44)	
	

	--RENDER TO 2D TEXTURE
	--Take the image from camera2 and copy to texture "Render1"
	--Toma imagen de camera2 y la copia a textura "Render1"	
	texture3d.render(Render1)
	    cam3d.set(camera2) --set camera 2
        cam3d.position(camera2,{BallPos.x-0.1,BallPos.y+3,BallPos.z}) --position / posicion
	    cam3d.eye(camera2,{BallPos.x,BallPos.y,BallPos.z}) --look at / Mira a	
	  	amg.light(1,1)
	    model3d.render(BKG);
		model3d.render(Suelo);
	    model3d.render(Pared);
		model3d.render(Bola);
		model3d.render(Ring);
	    model3d.render(Lava);		
		amg.light(1,0)
	texture3d.finish()		

	
	amg.update() --Update 3D engine / Actualiza motor 3D
    model3d.updatephysics() --Update physics / Actualiza fsica	
	screen.flip() 
	
end